// lame encoding functions for butt
//
// Copyright 2007 by Daniel Noethen.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//

#include <stdlib.h>
#include <lame/lame.h>
#include "port_audio.h"

#include "cfg.h"
#include "butt.h"
#include "lame_encode.h"
#include "port_audio.h"

#include "config.h"

lame_global_flags *gfp_stream;
lame_global_flags *gfp_record;

char* lame_buf;

int lame_enc_init()
{
    int rc;
    char info_buf[256];

    gfp_stream = lame_init();
    gfp_record = lame_init();

    lame_set_num_channels(gfp_stream, cfg.audio.channel);
    lame_set_in_samplerate(gfp_stream, cfg.audio.samplerate);
    lame_set_out_samplerate(gfp_stream, cfg.audio.samplerate);
    lame_set_brate(gfp_stream, cfg.audio.bitrate);
    //lame_set_mode(gfp_stream,(MPEG_mode)MONO);

    if((rc = lame_init_params(gfp_stream)) < 0)
    {
        snprintf(info_buf, sizeof(info_buf),
                "unable to init lame params %d",
                rc);

        print_info(info_buf, 1);
        return 1;
    }

    lame_set_num_channels(gfp_record, cfg.rec.channel);
    lame_set_in_samplerate(gfp_record, cfg.audio.samplerate);
    lame_set_out_samplerate(gfp_record, cfg.rec.samplerate);
    lame_set_brate(gfp_record, cfg.rec.bitrate);
    //lame_set_mode(gfp_record,(MPEG_mode)MONO);

    if((rc = lame_init_params(gfp_record)) < 0)
    {
        snprintf(info_buf, sizeof(info_buf),
                "unable to init lame rec params %d",
                rc);

        print_info(info_buf, 1);
        return 1;
    }
    return 0;
}

int lame_enc_reinit()
{
    lame_enc_close();
    return lame_enc_init();
}

/*
inline function - look at the header file
void lame_enc_close()
*/

int lame_enc_buf(short *pcm_buf, char *enc_buf, int samples, lame_global_flags *gfp, int size)
{
    if(samples == 0)
        return 0;

    if(cfg.audio.channel == 2)
        return lame_encode_buffer_interleaved(gfp, pcm_buf, samples, (unsigned char*)enc_buf, size);
    else
        return lame_encode_buffer(gfp, pcm_buf, pcm_buf, samples, (unsigned char*)enc_buf, size);
}

